//
//  MazeResolverExtension.swift
//  MazeBoard
//
//  Created by narita on 2017/07/13.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

// NSImageに描画する "環境" 関数を作る
extension MazeResolver
{
    public func DebugImage() -> NSImage
    {        
        let theScale : CGFloat = 1
        
        return NSImage.imageWithBlock(
            NSSize(width: CGFloat(self.width) * theScale, height: CGFloat(self.height) * theScale))
        {
            for i in (0 ..< self.height)
            {                
                for j in (0 ..< self.width)
                {                    
                    switch mazeBoard.typeFor( pos: MazePos(j, i) )
                    {
                    case .Digable:    NSColor.blue.set() // 掘れる壁
                    case .NotDigable: NSColor.blue.set() // 掘れない壁
                    case .Digged:
                        if self.route.contains( MazePos(j, i) )
                        {
                            NSColor.red.set() // 順路
                        }
                        else if self.deadEnd.contains( MazePos(j, i) )
                        {
                            NSColor.yellow.set() // 行き止まり
                        }
                        else
                        {
                            NSColor.black.set() // 通路
                        }
                    case .Start:      NSColor.red.set() // スタート位置。
                    case .Goal:       NSColor.red.set() // ゴール位置。
                    }
                    
                    NSBezierPath(rect: 
                        NSMakeRect( CGFloat(j) * theScale, CGFloat(i) * theScale, theScale, theScale))
                        .stroke()        
                }
            }
        }
    }
}
