import Cocoa

// NSImageに描画する "環境" 関数を作る
extension MazeBoard
{
    public func DebugImage() -> NSImage
    {        
        let theScale : CGFloat = 1
        
        return NSImage.imageWithBlock(
            NSSize(width: CGFloat(self.width) * theScale, height: CGFloat(self.height) * theScale))
        {
            for i in (0 ..< self.height)
            {                
                for j in (0 ..< self.width)
                {                    
                    switch self.typeFor( pos: MazePos(j, i) )
                    {
                        case .Digable:    NSColor.blue.set() // 掘れる壁
                        case .NotDigable: NSColor.blue.set() // 掘れない壁
                        case .Digged:     NSColor.black.set() // 掘ったから通路になった
                        case .Start:      NSColor.red.set() // スタート位置。
                        case .Goal:       NSColor.red.set() // ゴール位置。
                    }
                    
                    NSBezierPath(rect: 
                        NSMakeRect( CGFloat(j) * theScale, CGFloat(i) * theScale, theScale, theScale))
                        .stroke()        
                }
            }
        }
    }
}

