import Cocoa

// NSImageに描画する "環境" 関数を作る
extension NSImage
{
    public static func imageWithBlock(_ size: NSSize, _ closure: ()->() )  -> NSImage 
    {
        let theResult = NSImage(size:size)
        
        theResult.lockFocus()
        closure()
        theResult.unlockFocus()
        
        return theResult
    }
}

// ex: 点を1つ穿つ
//NSImage.imageWithBlock(NSSize(width:100, height:100))
//{
//    NSBezierPath(ovalIn: NSMakeRect(50, 50, 1, 1)).stroke()
//}
