//
//  ViewController.swift
//  MazeBoard
//
//  Created by narita on 2017/07/10.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class ViewController: NSViewController {

    override func viewDidLoad()
    {
        super.viewDidLoad()

        // Do any additional setup after loading the view.

        self.imageView.scaleUnitSquare(to: NSMakeSize(8, 8))

        self.maze = MazeBoard(width:50, height:50)

        // イベントループを回してnibの構築をさせた後に迷路の作成に入る。
        // 以下のコメントを外すと、すぐに迷路の作成開始。performSelectorは使用できない....
//        OperationQueue.main.addOperation 
//        {
//            self.makeMaze()
//        }
    }

    // firtResponder経由でコマンドNと結びつけてます。
    @IBAction func makeMaze( sender : NSMenu!)
    {
        slider.isEnabled = false

        slider.minValue = 0
        slider.maxValue = 0
        slider.integerValue = 0

        self.mazeImageArray = []
        
        // サブスレッドで実行する
        DispatchQueue(label:"sub").async
        {
            self.maze.doDig(MazePos(1,1))
            {                
                let outer_0 = $0

                DispatchQueue.main.sync
                {
                        self.mazeImageArray.append(outer_0.DebugImage())

                        // UIの更新はメインスレッドで実行される事
                        self.slider.minValue = 0
                        self.slider.maxValue = Double(self.mazeImageArray.count) - 1.0
                        self.slider.integerValue = Int(self.slider.maxValue)
                        
                        self.imageView.image = self.mazeImageArray[self.slider.integerValue ]  
                }
            }
            
            DispatchQueue.main.async
            {
                    // 完了処理もメインスレッドで
                self.resolveMaze(sender: nil)
            }
        }        
    }
    
    // 迷路を解く
    @IBAction func resolveMaze( sender: NSMenu!)
    {
        //         
        self.resolver = MazeResolver(self.maze)
        
        // サブスレッドで実行する
        DispatchQueue(label:"sub").async
        {
            self.resolver.resolve( MazePos(1,1) )
            {                             
                let outer_0 = $0
                
                DispatchQueue.main.sync
                {
                        self.mazeImageArray.append(outer_0.DebugImage())

                        // UIの更新はメインスレッドで実行される事
                        self.slider.minValue = 0
                        self.slider.maxValue = Double(self.mazeImageArray.count) - 1.0
                        self.slider.integerValue = Int(self.slider.maxValue)
                        
                        self.imageView.image = self.mazeImageArray[self.slider.integerValue ]  
                }
            }
            
            DispatchQueue.main.async
            {
                // 完了処理もメインスレッドで
                self.slider.isEnabled = true
                
                NSBeep()
            }
        }                
    }
    
    @IBAction func imageChange( sender : NSSlider!)
    {
        self.imageView.image = self.mazeImageArray[sender.integerValue ]
    }

    override var representedObject: Any? 
    {
        didSet 
        {
            // Update the view, if already loaded.
        }
    }

    @IBOutlet weak var slider: NSSlider!
    @IBOutlet weak var imageView: NSImageView!
    
    var mazeImageArray : Array<NSImage> = []
    var maze : MazeBoard! = nil
    var resolver : MazeResolver! = nil
}

